<?php 

include_once 'dbConfig.php';
require_once 'vendor/autoload.php';
use PhpOffice\PhpSpreadsheet\Reader\Xlsx;

if (isset($_POST['importSubmit'])) {

    // Allowed mime types
    $excelMimes = array('text/xls', 'text/xlsx', 'application/excel', 'application/vnd.msexcel', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');

    if (!empty($_FILES['file']['name']) && in_array($_FILES['file']['type'], $excelMimes)) {

        if (is_uploaded_file($_FILES['file']['tmp_name'])) {
            $reader = new Xlsx();
            $spreadsheet = $reader->load($_FILES['file']['tmp_name']);
            $worksheet = $spreadsheet->getActiveSheet();
            $worksheet_arr = $worksheet->toArray();

            // Remove the header row
            unset($worksheet_arr[0]);

            // Fetch the last inserted `ac_no` (or another unique identifier)
            $lastInserted = mysqli_query($db, "SELECT MAX(ac_no) AS last_ac_no FROM ward_91");
            $lastRow = mysqli_fetch_assoc($lastInserted);
            $lastAcNo = $lastRow['last_ac_no'];

            // Prepare the insert values
            $batchSize = 100;
            $values = [];
            $count = 0;
            foreach ($worksheet_arr as $row) {
                // Check if the `ac_no` of the current row is greater than the last inserted `ac_no`
                if ($row[0] > $lastAcNo) 
                {  // Assuming ac_no is unique and incremental
                    // Escape each value to avoid SQL syntax errors due to special characters
                    $ac_no = mysqli_real_escape_string($db, $row[0]);
                    $part_no = mysqli_real_escape_string($db, $row[1]);
                    $slno_in_part = mysqli_real_escape_string($db, $row[2]);
                    $section_no = mysqli_real_escape_string($db, $row[3]);
                    $house_number = mysqli_real_escape_string($db, $row[4]);
                    $app_full_name_l1 = mysqli_real_escape_string($db, $row[5]);
                    $app_full_name = mysqli_real_escape_string($db, $row[6]);
                    $app_first_name_l1 = mysqli_real_escape_string($db, $row[7]);
                    $app_first_name = mysqli_real_escape_string($db, $row[8]);
                    $app_last_name_l1 = mysqli_real_escape_string($db, $row[9]);
                    $app_last_name = mysqli_real_escape_string($db, $row[10]);
                    $age = mysqli_real_escape_string($db, $row[11]);
                    $gender = mysqli_real_escape_string($db, $row[12]);
                    $relation_type = mysqli_real_escape_string($db, $row[13]);
                    $relation_full_name_l1 = mysqli_real_escape_string($db, $row[14]);
                    $relation_full_name = mysqli_real_escape_string($db, $row[15]);
                    $relation_last_name_l1 = mysqli_real_escape_string($db, $row[16]);
                    $relation_last_name = mysqli_real_escape_string($db, $row[17]);
                    $epic_number = mysqli_real_escape_string($db, $row[18]);
                    $v_address_l1 = mysqli_real_escape_string($db, $row[19]);
                    $v_address = mysqli_real_escape_string($db, $row[20]);
                    $booth_address_l1 = mysqli_real_escape_string($db, $row[21]);
                    $booth_address = mysqli_real_escape_string($db, $row[22]);
                    $ytr_number = mysqli_real_escape_string($db, $row[23]);
                    $dob = mysqli_real_escape_string($db, $row[24]);
                    $phone1 = mysqli_real_escape_string($db, $row[25]);
                    $phone2 = mysqli_real_escape_string($db, $row[26]);
                    $phone3 = mysqli_real_escape_string($db, $row[27]);
                    $phone4 = mysqli_real_escape_string($db, $row[28]);
                    $phone5 = mysqli_real_escape_string($db, $row[29]);
                    $phone6 = mysqli_real_escape_string($db, $row[30]);
                    $phone7 = mysqli_real_escape_string($db, $row[31]);
                    $phone8 = mysqli_real_escape_string($db, $row[32]);
                    $phone9 = mysqli_real_escape_string($db, $row[33]);
                    $phone10 = mysqli_real_escape_string($db, $row[34]);

                    // Prepare the row values for insertion
                    $values[] = "('$ac_no', '$part_no', '$slno_in_part', '$section_no', '$house_number', 
                    '$app_full_name_l1', '$app_full_name', '$app_first_name_l1', '$app_first_name', 
                    '$app_last_name_l1', '$app_last_name', '$age', '$gender', '$relation_type', 
                    '$relation_full_name_l1', '$relation_full_name', '$relation_last_name_l1', '$relation_last_name', '$epic_number', 
                    '$v_address_l1', '$v_address', '$booth_address_l1', '$booth_address', '$ytr_number', '$dob', '$phone1', '$phone2', 
                    '$phone3', '$phone4', '$phone5', '$phone6', '$phone7', '$phone8', '$phone9', '$phone10')";

                    $count++;

                    // If batch size is reached, insert the current batch and reset values
                    if ($count >= $batchSize) 
                    {
                        // Prepare the INSERT query
                        $values_str = implode(",", $values);
                        $query = "INSERT INTO ward_91 (
                            ac_no, part_no, slno_in_part, section_no, house_number, 
                            applicant_full_name_l1, applicant_full_name, applicant_first_name_l1, applicant_first_name, 
                            applicant_last_name_l1, applicant_last_name, age, gender, relation_type, 
                            relation_full_name_l1, relation_full_name, relation_last_name_l1, relation_last_name, epic_number, 
                            v_address_l1, v_address, booth_address_l1, booth_address, ytr_number, dob, phone1, phone2, phone3, phone4, 
                            phone5, phone6, phone7, phone8, phone9, phone10
                        ) VALUES $values_str";

                        // Execute the query
                        if (!mysqli_query($db, $query)) {
                            $qstring = '?status=err&msg=' . urlencode(mysqli_error($db));
                            break;
                        }

                        // Reset for the next batch
                        $values = [];
                        $count = 0;
                    }
                }
            }

            if ($count > 0) {
                $values_str = implode(",", $values);
                $query = "INSERT INTO ward_91 (
                    ac_no, part_no, slno_in_part, section_no, house_number, 
                    applicant_full_name_l1, applicant_full_name, applicant_first_name_l1, applicant_first_name, 
                    applicant_last_name_l1, applicant_last_name, age, gender, relation_type, 
                    relation_full_name_l1, relation_full_name, relation_last_name_l1, relation_last_name, epic_number, 
                    v_address_l1, v_address, booth_address_l1, booth_address, ytr_number, dob, phone1, phone2, phone3, phone4, 
                    phone5, phone6, phone7, phone8, phone9, phone10
                ) VALUES $values_str";

                if (!mysqli_query($db, $query)) {
                    $qstring = '?status=err&msg=' . urlencode(mysqli_error($db));
                }
            }

            //$qstring = '?status=succ';
        } else {
            $qstring = '?status=invalid_file'; 
        }
    } else {
        $qstring = '?status=err'; 
    }
}

header("Location: index.php" . $qstring);
exit;
